 unit compiler_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls, util_u;

const typ1 : array[0..14] of string = ('NOP','EOP','PUSH','POP','GO','LEFT',
                                       'GET','PUT','RTS','TSTW','TSTF','TSTZ',
                                       'AND','OR','NOT');
      typ2 : array[0..0] of string = ('LDS');
      typ3 : array[0..3] of string = ('JMP','JSR','JFT','JFF');
      firsttime = true;

type
  TCompilerForm = class(TForm)
    LoadBtn: TButton;
    SaveBtn: TButton;
    ScanBtn: TButton;
    Memo1: TMemo;
    ParseBtn: TButton;
    Edit1: TEdit;
    AdressBtn: TButton;
    tabelle: TStringGrid;
    CompileBtn: TButton;
    ListBox1: TListBox;
    AllesBtn: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Edit3: TEdit;
    NeuBtn: TButton;
    SaveAsBtn: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    procedure LoadBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure init(ft:boolean);
    procedure CutRemarks;
    procedure scan(s:string);
    procedure Compile;
    procedure ScanBtnClick(Sender: TObject);
    procedure AdressenSchreiben;
    procedure SchreibeHex;
    procedure Parse;
    procedure Fehlermeldung(fc:byte; zz :integer);
    procedure ParseBtnClick(Sender: TObject);
    procedure AdressBtnClick(Sender: TObject);
    procedure CompileBtnClick(Sender: TObject);
    procedure AllesBtnClick(Sender: TObject);
    procedure NeuBtnClick(Sender: TObject);
    procedure Memo1Enter(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SaveAsBtnClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  CompilerForm: TCompilerForm;
  maxrz,rz,zz,pc,icmax: integer;
  weiter : boolean;
  ROM : array[0..1023] of byte;
  asmfilename, hexfilename, filename :string;



implementation
{$R *.DFM}
uses robisim_u;


type  PToken = ^TToken;
      TToken = (typ0_,typ1_,typ2_,typ3_);

      TLabel = record
        lname : string[8];
        ladr  : string[5];
      end;

var   TokenTabelle: TList;
      Labelarray : array of TLabel;


function standard(s : string):string;
var n : integer;
    hs : string;
    ch : char;
begin
  hs := '';
  while length(s) > 0 do begin
    ch := upcase(s[1]);
    if (ch in buchstaben) or (ch in ziffern) or (ch in sonderzeichen)then hs := hs+ch;
    if (ch = char(9)) then hs := hs+'    ';
    if (ch = ' ') then hs := hs+' ';
    delete(s,1,1);
  end;
  result := hs;
end;

procedure TCompilerForm.Fehlermeldung(fc : byte; zz : integer);
var hs : string;
begin
weiter := false;
case fc of
  1 : hs := 'ungltiges Label';
  2 : hs := 'Ungltiger Opcode';
  3 : hs := 'Ungltige Hex-Wert';
  4 : hs := '# erwartet';
  5 : hs := 'Label erwartet';
  6 : hs := 'Unbekanntes Label';
  7 : hs := 'Doppeltes Label';
  8 : hs := 'Falsche Anzahl vonParametern';
end;
Edit3.Color := clred;
Edit3.Text := hs+' in Zeile '+IntToStr(zz);
end;



procedure TCompilerForm.Init(ft:boolean);
var n : integer;
begin
ListBox1.Items.Clear;
for n := 0 to 1023 do ROM[n] := 0;
if ft then begin
  Memo1.Clear;
  Memo1.Lines[0] := '';
  filename :='ohnename';
  asmfilename := 'ohnename.asm';
  hexfilename := filename+'.hex';
end;
for n := 1 to Tabelle.RowCount-1 do begin
  Tabelle.Cells[0,n]:= '';  Tabelle.Cells[1,n]:= '';
  Tabelle.Cells[2,n]:= '';  Tabelle.Cells[3,n]:= '';
  Tabelle.Cells[4,n]:= '';
end;
zz := 0; pc :=0;
weiter := true;
Edit3.Text := '';Edit3.Color := clWindow;
ScanBtn.Enabled := true; ParseBtn.Enabled := false;
AdressBtn.Enabled := false; CompileBtn.Enabled := false;
AllesBtn.Enabled := true;
if Tokentabelle <> nil then TokenTabelle.Destroy;
TokenTabelle := TList.Create;
Edit1.Text := '..\'+filename+'.asm';
SetLength(Labelarray,0);
end;


procedure TCompilerForm.SchreibeHex;
var z : integer;
    hi,lo : byte;

  procedure WriteAdresse;
  begin
    HexToByte(Tabelle.Cells[4,z],hi,lo);
    ROM[rz] := hi; inc(rz); ROM[rz] := lo; inc(rz)
  end;

begin
rz := 0;
for z := 1 to zz do begin
  if Tabelle.Cells[3,z] = 'NOP'  then begin ROM[rz] := $00; inc(rz); end;
  if Tabelle.Cells[3,z] = 'EOP'  then begin ROM[rz] := $01; inc(rz); end;
  if Tabelle.Cells[3,z] = 'PUSH' then begin ROM[rz] := $02; inc(rz); end;
  if Tabelle.Cells[3,z] = 'POP'  then begin ROM[rz] := $03; inc(rz); end;
  if Tabelle.Cells[3,z] = 'GO'   then begin ROM[rz] := $04; inc(rz); end;
  if Tabelle.Cells[3,z] = 'LEFT' then begin ROM[rz] := $05; inc(rz); end;
  if Tabelle.Cells[3,z] = 'GET'  then begin ROM[rz] := $06; inc(rz); end;
  if Tabelle.Cells[3,z] = 'PUT'  then begin ROM[rz] := $07; inc(rz); end;
  if Tabelle.Cells[3,z] = 'RTS'  then begin ROM[rz] := $08; inc(rz); end;
  if Tabelle.Cells[3,z] = 'TSTW' then begin ROM[rz] := $09; inc(rz); end;
  if Tabelle.Cells[3,z] = 'TSTF' then begin ROM[rz] := $0A; inc(rz);end;
  if Tabelle.Cells[3,z] = 'TSTZ' then begin ROM[rz] := $0B; inc(rz);end;
  if Tabelle.Cells[3,z] = 'AND'  then begin ROM[rz] := $0C; inc(rz);end;
  if Tabelle.Cells[3,z] = 'OR'   then begin ROM[rz] := $0D; inc(rz);end;
  if Tabelle.Cells[3,z] = 'NOT'  then begin ROM[rz] := $0E; inc(rz);end;
  if Tabelle.Cells[3,z] = 'JMP'  then begin ROM[rz] := $30; inc(rz);WriteAdresse; end;
  if Tabelle.Cells[3,z] = 'JSR'  then begin ROM[rz] := $31; inc(rz);WriteAdresse;end;
  if Tabelle.Cells[3,z] = 'JFT'  then begin ROM[rz] := $32; inc(rz);WriteAdresse;end;
  if Tabelle.Cells[3,z] = 'JFF'  then begin ROM[rz] := $33; inc(rz);WriteAdresse;end;
  if Tabelle.Cells[3,z] = 'LDS'  then
    begin ROM[rz] := $20; inc(rz);
     ROM[rz] := HexStrToByte(Tabelle.Cells[4,z]);
     inc(rz);
    end;
end;
maxrz := rz;
end;

procedure TCompilerForm.AdressenSchreiben;
var z,oldpc : integer;
    pt : PToken;
begin
for z := 1 to zz do begin
  Tabelle.Cells[1,z] := hex(pc,4);
  pt := TokenTabelle[z-1];
  case  pt^ of
    typ1_ : inc(pc,1);
    typ2_ : inc(pc,2);
    typ3_ : inc(pc,3);
  end;
end;
end;

function StringToTokenPointer(s : string): PToken;
var n : integer;
    pt : PToken;
begin
  new(pt);
  pt^:= typ0_; result := pt;
  for n := 0 to 14 do if s = typ1[n] then begin pt^ := typ1_; result := pt; exit; end;
  if s = 'LDS' then begin pt^ := typ2_; result := pt; exit; end;
  for n := 0 to 4 do if s = typ2[n] then begin pt^ := typ3_; result := pt; exit; end;
end;


procedure  TCompilerForm.scan(s:string);
var w: String;
    pt : PToken;

  procedure NoLabel;
  begin
  if length(s) > 0 then begin
    w := '';
    repeat
      w := w+s[1];
      delete(s,1,1);
    until (length(s)= 0) or (s[1] = ' ' );
    trim(w);
    Tabelle.Cells[3,zz] := w;
    pt := StringToTokenPointer(w);
    Tokentabelle.Add(pt);
  end;
  s := trim(s);
  if length(s) > 0 then begin
    w := '';
    while (length(s) > 0) and (length(w) < 8) do begin
      w := w+s[1];
      delete(s,1,1);
    end;
    Tabelle.Cells[4,zz] := trim(w);
  end;
  end;

begin
inc(zz);
Tabelle.Cells[0,zz] := IntToStr(zz);
if (length(s) > 0) and (s[1] <> ' ') then begin
   w := '';
   repeat
     w := w+s[1];
     delete(s,1,1);
   until (length(s)= 0) or (s[1] = ' ');
   if length(w) > 8 then delete(w,9,length(w)-8);
   Tabelle.Cells[2,zz] := trim(w);
end;
repeat
  delete(s,1,1)
until (length(s)= 0) or (s[1] <>' ');
if length(s) > 0 then NoLabel else dec(zz);
end;


function CutFilename(s:string):string;
var p : integer;
begin
repeat
  p := pos('\',s);
  if p > 0 then delete(s,1,p);
until p = 0;
p := pos('.',s);
result := copy(s,1,p-1);
end;


procedure TCompilerForm.LoadBtnClick(Sender: TObject);
begin
asmfilename := '';
init(firsttime);
if OpenDialog1.Execute then asmfilename := OpenDialog1.Filename;
if FileExists(asmfilename) then begin
  filename := CutFilename(asmfilename);
  Edit1.Text := '..\'+filename+'.asm';
  hexfilename := filename+'.hex';
  Memo1.Lines.LoadFromFile(asmfilename);
  icmax := Memo1.Lines.Count;
  SaveDialog1.Filename := asmfilename;
end else Application.MessageBox('Datei nicht gefunden','Fehler beim ffnen', MB_OK)
end;


procedure TCompilerForm.SaveAsBtnClick(Sender: TObject);
begin
if SaveDialog1.Execute then Memo1.Lines.SaveToFile(SaveDialog1.FileName);
filename := CutFilename(SaveDialog1.FileName);
hexfilename := filename+'.hex';
Edit1.Text := '..\'+filename+'.asm';
//init;
end;


procedure TCompilerForm.FormCreate(Sender: TObject);
begin
Tabelle.ColWidths[0] := 40;Tabelle.ColWidths[1] := 50;
Tabelle.ColWidths[2] := 90; Tabelle.ColWidths[3] := 60;Tabelle.ColWidths[4] := 80;
Tabelle.Cells[0,0]:= ' ZZ';Tabelle.Cells[1,0]:= 'Adress';
Tabelle.Cells[2,0]:= '   Label';
Tabelle.Cells[3,0]:= ' OpCode';Tabelle.Cells[4,0]:= '  Operand';
init(firsttime);
end;

procedure TCompilerForm.CutRemarks;
var s : string;
    p,z :integer;
begin
for z := 1 to Memo1.Lines.Count do begin
  s := Memo1.Lines[z-1];
  p := pos(';',s);
  if p > 0 then delete(s,p,length(s)-p+1); // Kommentare abschneiden
  if length(s) > 0 then scan(standard(s));
end;
ScanBtn.Enabled := false;
end;

procedure TCompilerForm.Compile;
var m,n,l : integer;
    s1 : string;
begin
for n := 1 to zz do begin
  s1 := Tabelle.Cells[2,n];
  if  s1 <> '' then begin
    l := length(LabelArray);
    SetLength(LabelArray,l+1);
    LabelArray[l].lname := s1;
    LabelArray[l].ladr := Tabelle.Cells[1,n];
  end;
end;
for n := 1 to zz do begin
  s1 := copy(Tabelle.Cells[4,n],1,8);
  if  s1 <> '' then begin
    for m := 0 to l do
      if s1 = LabelArray[m].lname then
      Tabelle.Cells[4,n] := LabelArray[m].ladr;
  end;
end;
SchreibeHex;
for n := 0 to rz do ListBox1.Items.Add(hex(ROM[n],2));
end;


procedure TCompilerForm.ScanBtnClick(Sender: TObject);
begin
init(not firsttime);
CutRemarks;
AllesBtn.Enabled := false;
ScanBtn.Enabled := false;
ParseBtn.enabled := true;
end;


procedure TCompilerForm.parse;
var m,n,la : integer;
    l,opc,op : string;

          procedure Parse_l(s:string);
          var le,nn : integer;
          begin
            le := length(s);
            if le = 0 then fehlermeldung(5,n) else
            for nn:= 1 to length(s) do
              if not ((s[nn]in buchstaben ) or ( s[nn]in ziffern)) then fehlermeldung(1,n);
            end;

          procedure parse_hex;
          begin
          if op[1] <> '#' then fehlermeldung(4,n);
          if ( (not (op[2] ='$') and (op[3] in HexZiffern) and (op[4] in HexZiffern))) then fehlermeldung(3,n);
          end;

          procedure parse_opc;
          var pt : PToken;
          begin
          pt := StringToTokenPointer(opc);
            case  pt^ of
              typ0_ : fehlermeldung(2,n);
              typ1_ : if op <>'' then fehlermeldung(8,n);
              typ2_ : parse_hex;
              typ3_ : parse_l(op);
            end;
          end;

begin
n := 1;
while (n <=zz) and weiter do begin
  l := Tabelle.Cells[2,n]; opc := Tabelle.Cells[3,n]; op := Tabelle.Cells[4,n];
  if l <> '' then begin
    parse_l(l);
    if opc <>'' then parse_opc;
  end else parse_opc;
  inc(n);
  if l<>'' then begin
   la := length(LabelArray);
   SetLength(LabelArray,la+1);
   LabelArray[la].lname := l;
   m := 0;
   while (m < la) and ( la> 0 ) and (weiter) do
     if l = Labelarray[m].lname  then fehlermeldung(7,n) else inc(m);
 end;
end;
n := 1;
while (n <= zz) and weiter do begin
  op := Tabelle.Cells[4,n];
  if (op <> '') and (op[1] <> '#')  then begin
    m := 0;
    while (op <> Labelarray[m].lname) and (m <= la) do inc(m);
    if m > la then fehlermeldung(6,n);
  end;
  inc(n);
end;
if weiter then begin
  Edit3.Color := clGreen;
  Edit3.Text:= 'Parser hat keinen Fehler gefunden';
end else exit;
end;



procedure TCompilerForm.ParseBtnClick(Sender: TObject);
begin
parse;
if weiter then begin
  ParseBtn.Enabled := false;
  AdressBtn.Enabled := true;
end;
end;

procedure TCompilerForm.AdressBtnClick(Sender: TObject);
begin
AdressenSchreiben;
AdressBtn.enabled := false;
CompileBtn.enabled := true;
end;


procedure TCompilerForm.CompileBtnClick(Sender: TObject);
var hexfile : File of byte;
    z : integer;
    b : byte;
begin
compile;
assignfile(hexfile,hexfilename);
rewrite(hexfile);
for z := 0 to maxrz do begin
b := ROM[z];
write(hexfile,b);
end;
closefile(hexfile);
CompileBtn.Enabled := false;
end;


procedure TCompilerForm.AllesBtnClick(Sender: TObject);
var hexfile : File of byte;
    z : integer;
    b : byte;
begin
init(not firsttime);
CutRemarks;
parse;
if weiter then begin
  AdressenSchreiben;
  Compile;
  assignfile(hexfile,hexfilename);
  rewrite(hexfile);
  for z := 0 to maxrz do begin
    b := ROM[z];
    write(hexfile,b);
  end;
  closefile(hexfile);
  hide;
end;
end;

procedure TCompilerForm.NeuBtnClick(Sender: TObject);
begin
init(firsttime);
end;


procedure TCompilerForm.Memo1Enter(Sender: TObject);
begin
ScanBtn.Enabled := true; ParseBtn.enabled := true;
CompileBtn.Enabled := true; AdressBtn.enabled := true;
init(not firsttime);
end;


procedure TCompilerForm.Button1Click(Sender: TObject);
begin
hide;
end;

procedure TCompilerForm.SaveBtnClick(Sender: TObject);
begin
memo1.Lines.SaveToFile(filename+'.asm');
end;

end.
      