unit robi_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, util_u;

const  wall = 1; flower = 2; zero = 4; overflow = 8; // bits fr Statusregister

  Type

 TRichtung =( Nord, Ost,Sued,West,Tot);

  TRobi = class(TImage)
  private
    FVorrat : word;
    FRichtung : Trichtung;
    Fxpos, Fypos : integer;
    FGF : boolean;
  protected
    procedure Setxpos(x: integer);
    procedure Setypos(y : integer);
    procedure SetRichtung(r:TRichtung);
  public
    status :byte;
    pc : word;
    PROM : array[0..1023] of byte;
    AdressStack,LogikStack :TStack;
    constructor Create(AOwner: TComponent;ident,xs,ys: integer;r : TRichtung);
    procedure reset;
    procedure go;
    procedure turn;
    procedure push(p:pointer);
    procedure pop;
    procedure get;
    procedure put;
    procedure Maschine(var ausgabe: string; action : boolean);
    property xpos : integer read Fxpos write Setxpos;
    property ypos : integer read Fypos write Setypos;
    property Richtung : TRichtung read FRichtung write SetRichtung;
    property Vorrat : word read FVorrat write FVorrat default 0;
    property GeneralFlag : boolean read FGF write FGF default false;
  end;

implementation

uses robisim_u;

constructor TRobi.Create(Aowner:TComponent;ident,xs,ys:integer;r : TRichtung);
var pl : PLDaten;
begin
inherited Create(AOwner);
  LogikStack := TStack.Create;
  LogikStack.Init(256);
  new(pl); pl^:= false; LogikStack.Push(pl);
  AdressStack := TStack.Create; AdressStack.Init(10);
  width := 18; height := 18; xpos := xs; ypos := ys;
  richtung := r; vorrat := 0; pc := 0;
  tag := ident; status := 0;
end;

procedure TRobi.Reset;
begin
  xpos := 1; ypos := 1;
  richtung := ost; pc := 0;
  vorrat := 0; GeneralFlag := false;
end;

procedure TRobi.Setxpos(x:integer);
begin
  Fxpos := x;
  left :=  x*26+4;
end;

procedure TRobi.Setypos(y:integer);
begin
  Fypos := y;
  top := y*26+4;
end;

procedure TRobi.SetRichtung(r : TRichtung);
begin
FRichtung := r;
case r of
  west :Picture.Bitmap.LoadFromResourceName(HInstance, 'LINKS');
  ost  :Picture.Bitmap.LoadFromResourceName(HInstance, 'RECHTS');
  nord :Picture.Bitmap.LoadFromResourceName(HInstance, 'OBEN');
  sued :Picture.Bitmap.LoadFromResourceName(HInstance, 'UNTEN');
  tot  :begin
          Picture.Bitmap.LoadFromResourceName(HInstance, 'TOT');
          RobiSimForm.Timer1.Enabled := false;
        end;
end;
end;


procedure TRobi.go;
begin
case richtung of
  ost  : xpos := xpos+1;
  west : xPos := xpos-1;
  nord : ypos := ypos-1;
  sued : yPos := ypos+1;
end;
end;

procedure TRobi.turn;
begin
case richtung of
  west : begin richtung := sued; end;
  ost  : begin richtung := nord; end;
  nord : begin richtung := west; end;
  sued : begin richtung := ost;  end;
end;
end;

procedure TRobi.Get;
begin
 vorrat := vorrat+1;
end;


procedure TRobi.put;
begin
  vorrat := vorrat-1;
end;

procedure TRobi.push(p:pointer);
begin
 LogikStack.push(p);
end;

procedure TRobi.pop;
begin
 Logikstack.pop;
end;

procedure TRobi.Maschine(var ausgabe: string; action: boolean);
var adrhi, adrlo,wert : byte;
    pl : PLdaten;
    pa : PADaten;
begin
case PROM[pc] of
  $00 : begin ausgabe := 'NOP'; inc(pc); end;
  $01 : begin ausgabe := 'EOP' end;
  $02 : begin
           ausgabe := 'PUSH';
           if action then begin
             if not LogikStack.Full then begin
               new(pl); pl^:= GeneralFlag;
               LogikStack.push(pl);
             end else begin
               richtung := tot;
               Application.MessageBox('Stack OverFlow','', MB_OK);
               end;
           end;
           inc(pc);
           end;
  $03 : begin
          ausgabe := 'POP';
          if action then begin
            if not (LogikStack.Empty) then begin
              pl := LogikStack.Top;
              GeneralFlag := pl^;
              pop;
            end else begin
              richtung := tot;
              Application.MessageBox('Stack UnderFlow','', MB_OK);
            end;
          end;
          inc(pc);
        end;
  $04 : begin ausgabe := 'GO';if action then go;inc(pc); end;
  $05 : begin ausgabe := 'LEFT'; if action then turn; inc(pc); end;
  $06 : begin
          ausgabe := 'GET';
          if action then 
          if Feld[xpos,ypos].ft = 1 then begin
            get;
            RobiSimForm.NeuesFeld(xpos,ypos,0);
          end else richtung := tot;
          inc(pc);
        end;
  $07 : begin
          ausgabe := 'PUT';
          if action then
            if Feld[xpos,ypos].ft = 0 then begin
              put;
              RobiSimForm.NeuesFeld(xpos,ypos,1);
            end else richtung := tot;
          inc(pc);
        end;
  $08 : begin ausgabe := 'RTS';
          pa := AdressStack.top;
          pc := pa^+3 ;
          AdressStack.pop;
        end;
  $09 : begin
        ausgabe := 'TSTW';
        if (status and wall) = wall then GeneralFlag := true
        else GeneralFlag := false;
        inc(pc);
      end;
  $0A : begin
          ausgabe := 'TSTF';
          if (status and flower) = flower then GeneralFlag := true
          else GeneralFlag := false;
          inc(pc);
        end;
  $0B : begin
          ausgabe := 'TSTZ';
          if (status and zero) = zero then GeneralFlag := true
          else GeneralFlag := false;
          inc(pc);
       end;
  $0C : begin
          ausgabe := 'AND';
          pl := LogikStack.top;
          GeneralFlag := GeneralFlag and pl^;
          inc(pc);
       end;
  $0D : begin
          ausgabe := 'OR';
          pl := LogikStack.top;
          GeneralFlag := GeneralFlag or pl^;
          inc(pc);
       end;
  $0E : begin
          ausgabe := 'NOT';
          GeneralFlag := not GeneralFlag;
          inc(pc);
       end;
  $20 : begin
          inc(pc); wert := PROM[pc];
          ausgabe := 'LDS '+ hex(wert,2);
          if action then vorrat := wert;
          inc(pc);
        end;
  $30 : begin
          inc(pc);adrhi := PROM[pc];
          inc(pc);adrlo := PROM[pc];
          ausgabe := 'JMP '+ hex(256*adrhi+adrlo,4);
          pc := 256*adrhi+adrlo;
         end;
  $31 :  begin
           new(pa); pa^ := pc;
           AdressStack.push(pa);
           inc(pc); adrhi := PROM[pc];
           inc(pc); adrlo := PROM[pc];
           ausgabe := 'JSR '+hex(256*adrhi+adrlo,4);
           pc := 256*adrhi+adrlo;
         end;
  $32 :  begin
           inc(pc); adrhi := PROM[pc];
           inc(pc); adrlo := PROM[pc];
           ausgabe := 'JFT '+hex(256*adrhi+adrlo,4);
           if GeneralFlag then pc := 256*adrhi+adrlo else inc(pc);
           if action then GeneralFlag := false;
         end;
  $33 :  begin
           inc(pc); adrhi := PROM[pc];
           inc(pc); adrlo := PROM[pc];
           ausgabe := 'JFF '+hex(256*adrhi+adrlo,4);
           if not GeneralFlag then pc := 256*adrhi+adrlo else inc(pc);
           if action then GeneralFlag := false;
         end;
end;
end;


end.
