unit robisim_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, StdCtrls,robi_u, util_u, compiler_u;

const maxfeld = 16;
     
type

 TFeldInhalt = (blume,mauer,rbi1,rbi2);

 TFeld = record
    ft : byte;   //0: leer; 1 : blmchen; 2 : mauer: ev. usw.
    re : TShape;  // das zugehrige Rechteck
    bl : TShape  // blmchen
  end;

 TRobiSimForm = class(TForm)
    MainMenu1: TMainMenu;
    TeachinPanel: TPanel;
    GoBtn: TButton;
    TurnBtn: TButton;
    GetBtn: TButton;
    PutBtn: TButton;
    ResetBtn: TButton;
    LoadBtn: TButton;
    Edit1: TEdit;
    ProzessorPnl: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Feld1: TMenuItem;
    Laden1: TMenuItem;
    Assembler1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Edit2: TEdit;
    Label7: TLabel;
    OpenDialog2: TOpenDialog;
    Panel1: TPanel;
    StepBtn: TButton;
    RunBtn: TButton;
    Panel2: TPanel;
    Label8: TLabel;
    Edit3: TEdit;
    Timer1: TTimer;
    Speichern3: TMenuItem;
    SaveDialog1: TSaveDialog;
    Speichern4: TMenuItem;
    Label9: TLabel;
    Label10: TLabel;
    datei1: TMenuItem;
    Laden2: TMenuItem;
    Beenden1: TMenuItem;
    Label3: TLabel;
    Edit5: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure NeuesFeld(x,y: integer; b : byte);
    procedure NeueBlume(x,y:integer);
    procedure GoBtnClick(Sender: TObject);
    procedure TurnBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Laden1Click(Sender: TObject);
    procedure GetBtnClick(Sender: TObject);
    procedure PutBtnClick(Sender: TObject);
    procedure LadenClick(Sender: TObject);
    procedure FeldEditierenClick(Sender: TObject);
    procedure FeldClearClick(Sender: TObject);
    procedure StepBtnClick(Sender: TObject);
    procedure RunBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Speichern3Click(Sender: TObject);
    procedure FeldMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ScanWorld;
    procedure Neustart;
    procedure Assembler1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  RobiSimForm: TRobiSimForm;
  robi1 : TRobi;
  Feld : array[0..maxfeld+1,0..maxfeld+1] of TFeld;
  editenabled : boolean;


implementation
{$R *.DFM}

const noaction = false; action = true;

procedure TRobiSimForm.ScanWorld;
var p : pointer;
    bp : ^boolean;
begin
// bit 0 : wall; bit 1 : blume; bit 2 : zero-flag; bit 3 : Overflow;
  with robi1 do begin
    status := status and (255-1-2-4-8); // lsche bits 0,1,2,3
    if feld[xpos,ypos].bl <> nil then status := status or flower; //Blume gefunden
    if vorrat = 0 then status := status or zero;   //vorrat = 0
    if vorrat = 256 then status := status or overflow; // vorrat > 255
    if (xpos = 0) or (xpos = maxfeld+1) or (ypos = 0) or (ypos = maxfeld+1) then richtung := tot;
    case richtung of
      ost : if feld[xpos+1,ypos].re.brush.Style = bsDiagCross then status := (status or wall);
      west: if feld[xpos-1,ypos].re.brush.Style = bsDiagCross then status := (status or wall);
      nord: if feld[xpos,ypos-1].re.brush.Style = bsDiagCross then status := (status or wall);
      sued: if feld[xpos,ypos+1].re.brush.Style = bsDiagCross then status := (status or wall);
    end;
    Label4.Caption := bin(robi1.status); Label1.Caption := hex(robi1.vorrat,2);
    If GeneralFlag  then Edit5.Text := 'TRUE' else Edit5.Text := 'FALSE';
    if (not LogikStack.empty) then begin
      p := LogikStack.Top; {bp := p;}
    end;
    if feld[xpos,ypos].ft = 2 then richtung := tot;

 end
end;


procedure TRobiSimForm.FormCreate(Sender: TObject);
var x,y : integer;
    r : TShape;
begin
for x:=0 to maxfeld+1 do
  for y:= 0 to maxfeld+1 do begin
    r := TShape.Create(self);
    r.OnMouseDown := FeldMouseDown;
    with r do begin
      pen.Style := pssolid;
      pen.Color := clblack;
      width := 26; height := 26;
      top := y*26; left := x*26;
      if (x = 0) or (y = 0) or (x = maxfeld+1) or (y = maxfeld+1)
      then brush.Style := bsDiagCross else brush.Style := bsSolid;
      r.tag := 16*y+x;
      Parent := self;
      Feld[x,y].re := r; Feld[x,y].bl := nil; Feld[x,y].ft :=0;
    end;
end;
robi1 := TRobi.Create(self,1,1,1,ost);
robi1.Parent := self;
LoadBtn.Caption := 'Load';
//Speichern2.Caption := 'Start Edit';
editenabled := true;
ScanWorld; HexFileName :='';
CreateDir(GetCurrentDir+'\jobs');
end;


procedure TRobiSimForm.NeueBlume(x,y:integer);
var flower : TShape;
begin
flower := TShape .Create(self);
with flower do begin
  Shape := stcircle; width := 5; height := 5;
  top :=y*26+12;left := x*26+11;
  Brush.Color := clred;
end;
InsertControl(flower);
Feld[x,y].bl := flower;
end;

procedure TRobiSimForm.NeuesFeld(x,y: integer; b : byte);
begin
case b of
  0 : begin
        with Feld[x,y] do begin
          re.brush.Style := bsSolid;
          if bl <> nil then bl.destroy;
          bl := nil;
        end;
      end;
  1 : NeueBlume(x,y);
  2 : Feld[x,y].re.brush.Style := bsDiagCross;
end;
Feld[x,y].ft := b;
end;

procedure TRobiSimForm.GoBtnClick(Sender: TObject);
begin
if (robi1.status and wall) = 0 then robi1.go;
ScanWorld;
end;

procedure TRobiSimForm.TurnBtnClick(Sender: TObject);
begin
robi1.turn; ScanWorld;
end;


procedure TRobiSimForm.Neustart;
var ausgabe : string;
begin
Timer1.enabled := false;
if RunBtn.Caption ='Stop' then RunBtn.Caption :='Run' ;
if HexFileName <>'' then begin
  Robi1.Maschine(ausgabe,false);
  Edit2.Text := ausgabe;
end;
robi1.reset;
Label6.Caption := Hex(robi1.pc,4);
ScanWorld;
end;



procedure TRobiSimForm.ResetBtnClick(Sender: TObject);
begin
Neustart;
end;

procedure TRobiSimForm.LoadBtnClick(Sender: TObject);
begin
robi1.vorrat := StrToInt(Edit1.Text);
ScanWorld;
end;


procedure TRobiSimForm.Beenden1Click(Sender: TObject);
begin
Close;
end;

procedure TRobiSimForm.Laden1Click(Sender: TObject);
var ffname :string;
    x,y: integer;
    ff : file of byte;
    b : byte;
begin
OpenDialog1.Title := 'Robis Welt laden';
if OpenDialog1.Execute then ffname := OpenDialog1.FileName;
if FileExists(ffname) then begin
  assignfile(ff,ffname); reset(ff);
  for x := 1 to 16 do
    for y := 1 to 16 do begin
      read(ff,b);
      Neuesfeld(x,y,b);
    end;
    robi1.reset;
end else Application.MessageBox('Datei nicht gefunden','Fehler beim ffnen', MB_OK);
Scanworld;
end;

procedure TRobiSimForm.GetBtnClick(Sender: TObject);
begin
with robi1 do
  if (feld[xpos,ypos].ft = 1) and ((status and overflow) = 0) then begin
    get;
    NeuesFeld(xpos,ypos,0);
    ScanWorld;
  end;
end;


procedure TRobiSimForm.PutBtnClick(Sender: TObject);
begin
with robi1 do
  if (status and (flower+zero)) = 0 then begin
    put;
    NeuesFeld(xpos,ypos,1);
    ScanWorld;
   end;
end;


procedure TRobiSimForm.FeldClearClick(Sender: TObject);
var x,y : integer;
begin
for x := 1 to maxfeld do
  for y := 1 to maxfeld do Neuesfeld(x,y,0);
end;


procedure TRobiSimForm.FeldEditierenClick(Sender: TObject);
begin
editenabled := true;
//editenabled := not editenabled;
//if editenabled then Speichern2.Caption := 'Stop Edit' else Speichern2.Caption := 'Start Edit'
end;



procedure TRobiSimForm.LadenClick(Sender: TObject);
var hexf : file of byte;
    p,z : integer;
    b : byte;
begin
z := 0;
//FeldClearClick(self);
if OpenDialog2.Execute then HexFileName := OpenDialog2.FileName;
if FileExists(HexFileName) then begin
  assignfile(hexf,HexFileName); reset(hexf);
  while not eof(hexf) do begin
   read(hexf,b);
   robi1.PROM[z] := b;
   inc(z);
  end;
  p := pos('\',HexFileName);
  while p > 0 do begin
    delete(HexFileName,1,p);
    p := pos('\',HexFileName);
  end;
  Edit3.Text := HexFileName;
end  else Application.MessageBox('Datei nicht gefunden','Fehler beim ffnen', MB_OK);
ResetBtnClick(self);
Scanworld;
end;


procedure TRobiSimForm.StepBtnClick(Sender: TObject);
var ausgabe : string;
    oldpc : integer;
begin
  ScanWorld;
  Robi1.Maschine(ausgabe,true);
  oldpc := robi1.pc;
  ScanWorld;
  Robi1.Maschine(ausgabe,false);
  robi1.pc := oldpc;
  Edit2.Text := ausgabe;
  Label6.Caption  := hex(robi1.pc,4);
end;

procedure TRobiSimForm.RunBtnClick(Sender: TObject);
begin
Timer1.Enabled := not Timer1.enabled;
if RunBtn.Caption = 'Run' then RunBtn.Caption := 'Stop'
else begin
  RunBtn.Caption := 'Run';
//  ResetBtnClick(self);
end;
scanworld;
end;

procedure TRobiSimForm.Timer1Timer(Sender: TObject);
var ausgabe : string;
begin
  Label6.Caption  := hex(robi1.pc,4);
  Robi1.Maschine(ausgabe,true);
  Edit2.Text := ausgabe;
  ScanWorld;
end;

procedure TRobiSimForm.Speichern3Click(Sender: TObject);
var ff : File of Byte ;
    x,y,b : byte;
begin
SaveDialog1.Title := 'Robis Welt speichern';
  if SaveDialog1.Execute then begin
    AssignFile(ff, SaveDialog1.FileName);
    rewrite(ff);
      for x := 1 to maxfeld do begin
        for y := 1 to maxfeld do begin
          b := feld[x,y].ft;
          write(ff,b);
        end;
      end;
      closefile(ff);
  end;
end;



procedure TRobiSimForm.FeldMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var xx,yy : Byte;
begin
If editenabled then begin
  yy := (Sender as TShape).tag div 16; xx := (Sender as TShape).tag mod 16;
  if xx = 0 then begin yy:=yy-1; xx := 16; end;
  if Button = mbRight then
  case Feld[xx,yy].ft of
   0 : NeuesFeld(xx,yy,1);
   1 : NeuesFeld(xx,yy,0);
   end;
  if Button = mbLeft then
  case Feld[xx,yy].ft of
   0 : NeuesFeld(xx,yy,2);
   2 : NeuesFeld(xx,yy,0);
   end;
end;
end;

procedure TRobiSimForm.Assembler1Click(Sender: TObject);
begin
compilerform.show;
end;


procedure TRobiSimForm.FormActivate(Sender: TObject);
var n : integer;
begin
for n := 0 to rz do robi1.prom[n] := ROM[n];
if (filename <> '')  then begin
  Edit3.Text := HExFileName;
  neustart;
end;  
end;


end.
