unit util_u;

interface
uses classes;

const
     buchstaben = ['A'..'Z','_'];
     ziffern = ['0'..'9'];
     sonderzeichen = ['$','#'];
     hexziffern=['0'..'9','A'..'F'];
     h : array[0..3] of integer = (4096,256,16,1);
     hz : array[0..15] of char = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');

type

TStack = class(TList)
     private
        stacksize : integer;
     public
       procedure init(sz : integer);
       procedure push(p: pointer);
       procedure pop;
       function Top:pointer;
       function empty : Boolean;
       function Full : Boolean;
       function GetStackSize: integer;
  end;

PLDaten = ^boolean;
PADaten = ^word;

function hex(s:integer;sz : byte):string;
procedure HexToByte(s:string; var hi,lo : byte);
function HexStrToByte(s: string) :integer;
function bin( s: integer): string;
function IstHExZiffer(ch : char) : boolean;
function IstZiffer(ch : char) : boolean;
function IstBuchstabe(ch : char) : boolean;
function IstSonderzeichen(ch : char) : boolean;
procedure NoTrash(var s:string);

implementation

procedure TStack.init(sz : integer);
begin
stacksize := sz;
end;

function TSTack.empty;
begin
  result := (count = 0);
end;

function TStack.Full;
begin
  result := (count = stacksize);
end;

function TStack.GetStackSize: integer;
begin
  result := stacksize;
end;

procedure TStack.push(p: pointer);
begin
if not full then Insert(0,p);
end;


procedure TStack.pop;
begin
if not empty then Delete(0);
end;

function TStack.Top:pointer;
begin
 if not empty then result := Items[0];
end;


function hex( s: integer; sz: byte): string;
var hs : string;
    k,q : byte;
begin
hs := '$';
for k := (4-sz) to 3 do begin
   q := s div h[k];
   s := s mod h[k];
   hs := hs+hz[q];
end;
result := hs;
end;

procedure HexToByte(s:string; var hi,lo : byte);
var n,k,r : byte;
begin
delete(s,1,1); r := 0;
for n := 0 to 1 do begin
  k := 0;
  while s[1] <> hz[k] do inc(k);
  r := r+k*h[n];
  delete(s,1,1);
end;
hi := r; r := 0;
for n := 2 to 3 do begin
  k := 0;
  while s[1] <> hz[k] do inc(k);
  r := r+k*h[n];
  delete(s,1,1);
end;
lo :=r;
end;

function HexStrToByte(s: string) :integer;
var r,n,k: integer;
begin
delete(s,1,2); r := 0;
for n := 2 to 3 do begin
  k := 0;
  while s[1] <> hz[k] do inc(k);
  r := r+k*h[n];
  delete(s,1,1);
end;
result := r;
end;

function bin( s: integer): string;
var hs : string;
    k : byte;
begin
hs := '';
for k := 0 to 7 do begin
   if (s and 1)= 1 then hs := '1'+hs  else hs := '0'+hs;
   s := s shr 1;
end;
result := hs;
end;

function IstHExZiffer(ch : char) : boolean;
begin
result := false;
if (ch in HexZiffern) then result := true;
end;

function IstZiffer(ch : char) : boolean;
begin
result := false;
if (ch in Ziffern) then result := true;
end;

function IstBuchstabe(ch : char) : boolean;
begin
result := false;
if (ch in Buchstaben) then result := true;
end;

function IstSonderzeichen(ch : char) : boolean;
begin
result := false;
if (ch in Sonderzeichen) then result := true;
end;

procedure NoTrash(var s:string);
var ss : string;
    ch : char;
begin
ss := '';
while length(s) > 0 do begin
  ch := s[1];
  if IstBuchstabe(ch) or IstZiffer(ch) then ss := ss+ ch;
  delete(s,1,1);
end;
s := ss;
end;

end.
